' Small sample program for incClean2.dll v1.3
' This demo shows a way to call doIncLean() from your own code
' in order to let incClean2.dll pre-process and PBWin.exe compile
' a given main code file.
'
' Please read incLean2.txt for instructions and more information.
'
#COMPILE EXE
'#INCLUDE "WIN32API.INC"
'#INCLUDE "COMDLG32.INC"
#INCLUDE "DLLTEST.INC" '<- made by inclean2.dll for faster compile..

DECLARE CALLBACK FUNCTION DlgProc() AS LONG
DECLARE FUNCTION WasCompilerError(BYVAL orgFile AS STRING) AS LONG
'-------------------------------------------------------------------- 
DECLARE FUNCTION doFileExist LIB "INCLEAN2.DLL" _
          ALIAS "doFileExist" (BYVAL sfName AS STRING) AS LONG
 
DECLARE FUNCTION doIncLean LIB "INCLEAN2.DLL"_
          ALIAS "doIncLean" (BYVAL hParent AS DWORD, _
                 BYVAL sMainFile AS STRING, BYVAL ResultIncFile AS STRING, _
                 BYVAL sIncludePath AS STRING, OPT BYVAL CommCtrlInc AS LONG, _
                 OPT BYVAL ComDlg32Inc AS LONG, OPT BYVAL RichEditInc AS LONG, _
                 OPT BYVAL MDI32Inc AS LONG) AS LONG
 
'
' Create dialog and controls, etc
'
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD
 
  DIALOG NEW 0, "incLean2.dll + PBWin.exe sample",,, 240, 120, _
                 %WS_CAPTION OR %WS_SYSMENU, 0 TO hDlg
 
  CONTROL ADD BUTTON, hDlg, %IDOK,  "&Compile", 132, 102, 50, 14
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Quit", 186, 102, 50, 14
 
  sMainFile$ = "C:\PBWin70\Samples\SDK\PBNote1\PBNote.bas"
  CONTROL ADD LABEL, hDlg, 10, "Main code file:  (adjust path if you need..)", 6, 2, 140, 10
  CONTROL ADD TEXTBOX, hDlg, 30, sMainFile$, 5, 12, 209, 13
  CONTROL ADD BUTTON,  hDlg, 120, "...",   215, 12,  20, 14
 
  sInclPath$ = "C:\PBWin70\WinAPI\"
  CONTROL ADD LABEL, hDlg, 10, "PB include files path:  (adjust path..)", 6, 30, 140, 10
  CONTROL ADD TEXTBOX, hDlg, 31, sInclPath$, 5, 40, 229, 13

  ResultIncFile$ = "C:\PBWin70\Samples\SDK\PBNote1\PBNote.inc"
  CONTROL ADD LABEL, hDlg, 10, "Resulting output include file:  (adjust path..)", 6, 58, 140, 10
  CONTROL ADD TEXTBOX, hDlg, 32, ResultIncFile$,  5, 68, 229, 13

  CONTROL ADD CHECKBOX, hDlg, 40, "Display compiler result before run ",  6, 105, 120, 10

  DIALOG SHOW MODAL hDlg CALL DlgProc
 
END FUNCTION
 
'
' Main callback
'
CALLBACK FUNCTION DlgProc() AS LONG
  LOCAL lRes AS LONG, dwStyle AS DWORD, fName AS STRING, sBuf AS STRING
  STATIC Path AS STRING
 
  SELECT CASE CBMSG
     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE 120 'Browse
              dwStyle  = %OFN_EXPLORER OR %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY
              fName  = "*.BAS"
              sBuf = "PB Code files (*.BAS)|*.BAS|"
              IF LEN(Path) = 0 THEN Path = CURDIR$

              IF OpenFileDialog(CBHNDL, "", fName, Path, sBuf, "BAS" , dwStyle) THEN
                 IF DoFileExist(fName) THEN
                    Path = LEFT$(fName, INSTR(-1, fName, ANY "\/"))
                    CONTROL SET TEXT CBHNDL, 30, fName

                    fName = LEFT$(fName, INSTR(-1, fName, ".")) + "inc" ' make a matching inc file name
                    CONTROL SET TEXT CBHNDL, 32, fName
                 END IF
              END IF

           CASE %IDOK
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 CONTROL GET TEXT CBHNDL, 30 TO sMainFile$
                 CONTROL GET TEXT CBHNDL, 31 TO sInclPath$
                 CONTROL GET TEXT CBHNDL, 32 TO ResultIncFile$

                 lRes = INSTR(-1, sMainFile$, ".")
                 IF lRes THEN sExeFile$ = LEFT$(sMainFile$, lRes) + "exe"

                 lRes = INSTR(-1, UCASE$(sInclPath$), "\PBWIN70\")
                 IF lRes THEN PBcompiler$ = LEFT$(sInclPath$, lRes + 8) + "Bin\PBWin.exe"

                 IF doFileExist(sMainFile$) AND doFileExist(sInclPath$) THEN
                    ' here an editor or visual designer should make sure all files are saved..
                    MOUSEPTR 11
                    CONTROL DISABLE CBHNDL, %IDOK
                    CONTROL DISABLE CBHNDL, %IDCANCEL
                    lRes = doIncLean(CBHNDL, sMainFile$, ResultIncFile$, sInclPath$, 1, 1, 1, 1) '<- START

                    IF lRes > 0 THEN  ' incLean2 is done, time for PBWin to compile
                       IF doFileExist(ResultIncFile$) THEN
                          sInclPath$ = $DQ + sInclPath$ + $DQ  '<- in case it's a long path name
                          sMainFile$ = $DQ + sMainFile$ + $DQ  '   (not 100% sure this is correct way, but..)
 
                          ' time to start PBWin.exe and compile what we have.
                          ' note - two modes, quiet or display compiler result
                          ' /L to create log is always good here - else no error log..
                          CONTROL GET CHECK CBHNDL, 40 TO compShowResult&
                          IF compShowResult& = 0 THEN     ' create log, but quiet mode
                             SHELL PBcompiler$ + " /I" + sInclPath$ + " /L /Q " + sMainFile$
                          ELSE                            ' create log, but display result
                             SHELL PBcompiler$ + " /I" + sInclPath$ + " /L " + sMainFile$
                          END IF

                          IF WasCompilerError(sExeFile$) = 0 THEN ' if no error msg in compiler log
                             IF doFileExist(sExeFile$) THEN       ' if there
                                lRes = SHELL(sExeFile$)           ' run compiled exe when done..
                             END IF
                          ELSE
                             IF compShowResult& = 0 THEN
                                ' was compiler error - beep or show a message, whatever you like..
                             END IF
                          END IF
 
                       ELSE
                          MOUSEPTR 1
                          sBuf = "incLean2 DLL failed - no, or incorrect output file given." ' error message
                          MSGBOX sBuf, %MB_ICONWARNING, "incClean2.dll error message:"
                       END IF
                    ELSE
                       MOUSEPTR 1
                       SELECT CASE lRes
                          CASE -1 : sBuf = "main code file name is empty."
                          CASE -2 : sBuf = "output file name is empty"
                          CASE -3 : sBuf = "PB includes path is empty"
                          CASE -4 : sBuf = "PB include files path is broken or empty"
                          CASE -5 : sBuf = "OutPut file name already exist, but could not be " + _
                                          "opened. Please make sure file is closed and try again."
                          CASE -6 : sBuf = "output file name already exist with other format or contents."
                          CASE -7 : sBuf = "Main source code could not be found."
                          CASE -8 : sBuf = "No main PB code file with a COMPILE statement found."
                          CASE ELSE : sBuf = "An error has ocurred. Please check paths and try again"
                       END SELECT
                       MSGBOX sBuf, %MB_ICONWARNING, "incClean2.dll error message:"
                    END IF
                    MOUSEPTR 1
                    CONTROL ENABLE CBHNDL, %IDOK
                    CONTROL ENABLE CBHNDL, %IDCANCEL
                 ELSE
                    MOUSEPTR 1
                    sBuf =  "CodeFile or include path does not exist!"
                    MSGBOX sBuf, %MB_ICONWARNING, "incClean2.dll error message:"
                 END IF
              END IF
 
           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 DIALOG END CBHNDL
              END IF
 
        END SELECT
  END SELECT
END FUNCTION

'
' See if a compiler error has been logged
'
FUNCTION WasCompilerError(BYVAL orgFile AS STRING) AS LONG
  LOCAL pos AS LONG, hFile AS LONG, buf AS STRING, logFile AS STRING

  pos = INSTR(-1, orgFile, ".")              'find prefix part
  IF pos THEN                                'if dot is found
     logFile = LEFT$(orgFile, pos) + "log"   'make file prefix .LOG
  ELSE                                       'else
     logFile = orgFile + ".log"              'try by simply adding .LOG
  END IF

  IF doFileExist(logFile) THEN               'check that log file exists
     hFile = FREEFILE                        'get a free file handle
     OPEN logFile FOR BINARY AS hFile        'open log file
     GET$ hFile, LOF(hFile), buf             'get contents into string
     CLOSE hFile                             'close log file
  ELSE
     EXIT FUNCTION                           'else no log file, so exit function
  END IF

  FUNCTION = INSTR(buf, $CRLF + "Error ")    'returns 0 on no error, else a value (pos)
END FUNCTION
